zoukankan      html  css  js  c++  java
  • 【poj2709】Painter--贪心

    Painter
    Time Limit: 1000MS   Memory Limit: 65536K
    Total Submissions: 5621   Accepted: 3228

    Description

    The local toy store sells small fingerpainting kits with between three and twelve 50ml bottles of paint, each a different color. The paints are bright and fun to work with, and have the useful property that if you mix X ml each of any three different colors, you get X ml of gray. (The paints are thick and "airy", almost like cake frosting, and when you mix them together the volume doesn't increase, the paint just gets more dense.) None of the individual colors are gray; the only way to get gray is by mixing exactly three distinct colors, but it doesn't matter which three. Your friend Emily is an elementary school teacher and every Friday she does a fingerpainting project with her class. Given the number of different colors needed, the amount of each color, and the amount of gray, your job is to calculate the number of kits needed for her class.

    Input

    The input consists of one or more test cases, followed by a line containing only zero that signals the end of the input. Each test case consists of a single line of five or more integers, which are separated by a space. The first integer N is the number of different colors (3 <= N <= 12). Following that are N different nonnegative integers, each at most 1,000, that specify the amount of each color needed. Last is a nonnegative integer G <= 1,000 that specifies the amount of gray needed. All quantities are in ml.

    Output

    For each test case, output the smallest number of fingerpainting kits sufficient to provide the required amounts of all the colors and gray. Note that all grays are considered equal, so in order to find the minimum number of kits for a test case you may need to make grays using different combinations of three distinct colors.

    Sample Input

    3 40 95 21 0
    7 25 60 400 250 0 60 0 500
    4 90 95 75 95 10
    4 90 95 75 95 11
    5 0 0 0 0 0 333
    0
    

    Sample Output

    2
    8
    2
    3
    4
    

    Source

      思路:

    给出几种颜色需求的ml量,然后最后一个数是灰色需求量,灰色可以由任何三中不同颜色的颜色组成,每个颜料盒有所给出的颜色的炎凉50ml

    问最少给出几个颜料盒,可以组成所需求颜色

    显然贪心可以解决,先求出满足的普通色所需的最小盒数,然后把剩余颜料从大到小排列,那前三种每个取出1ml组成1

    ml的灰色,在这里本来我是把选出三个颜色中,直接选取第三个(最小容量)的所有容量k,组成kml的灰色,后来发现不行,贪心必须每次都要要求最好

    所以每次1ml来选才能达到要求

    代码:

    #include<cstdio>
    #include<iostream>
    #include<cstdlib>
    #include<algorithm>
    #define N 10000
    using namespace std;
    int n,col[N],mx=-1,gray,cnt;
    bool cmp(int a,int b){return a>b;}
    int main()
    {
    	while(scanf("%d",&n) == 1 && n != 0)
    	{
    		mx=-1,cnt=0;
    		for(int i=1;i<=n;i++)
    		{
    			scanf("%d",&col[i]);
    			mx=max(mx,col[i]);
    		}
    		scanf("%d",&gray);
    		cnt+=(mx/50);
    		if(mx%50!=0)cnt++;
    		for(int i=1;i<=n;i++)col[i]=cnt*50-col[i];
    		while(gray>0)
    		{
    			
    			sort(col+1,col+n+1,cmp);
    			if(col[3]>0)
    			{
    				gray--;
    				col[1]--;
    				col[2]--;
    				col[3]--;
    			}
    			else
    			{
    				cnt++;
    				for(int i=1;i<=n;i++)col[i]+=50;
    			}
    		}
    		printf("%d
    ",cnt);
    	}
    }
    
  • 相关阅读:
    scrapy练习1
    sys.path.append()加入当前目录为环境变量
    同济:003.映射与函数3
    1-4 无监督学习(Unsupervised Learning)
    1-3.监督学习(supervised learning)
    同济:002.映射与函数2
    github访问过慢解决
    LeetCode OJ:Contains Duplicate(是否包含重复)
    LeetCode OJ:Maximum Product Subarray(子数组最大乘积)
    LeetCode OJ:Valid Anagram(有效字谜问题)
  • 原文地址:https://www.cnblogs.com/yelir/p/11574921.html
Copyright © 2011-2022 走看看